<script setup>
import AppShare from '@/helpers/AppShare'
import { useDialogStore } from '@/stores/DialogStore';
import { useAppStore } from '@/stores/AppStore'
</script>


<script>
export default {

	data() {
		const appStore = useAppStore()
		return {
			appStore,
			name: appStore.member ? appStore.member.name : '',
		}
	},

	watch: {
		'appStore.member'(current, old) {
			this.name = current.name
		}
	},

	methods: {
		async onSubmit() {
			const dialogStore = useDialogStore()
			const result = await dialogStore.waitBox(async () =>
				await AppShare.client.call(`profile/name`, {
					method: 'PUT',
					headers: AppShare.client.defaultHeaders(),
					data: {
						member: {
							name: this.name,
						},
					},
				})
			)
			if (!dialogStore.handleRestError(result)) {
				this.appStore.member.name = this.name
				this.$router.push({ name: 'home' })
			}
		}
	},

	i18n: {
		messages: {
			en: {
				title: "Change Name",
				name: "Current Name",
				ok: "Change Name",
			},
			th: {
				title: "เปลี่ยนชื่อ",
				name: "ชื่อปัจจุบัน",
				ok: "เปลี่ยนชื่อ",
			},
		},
	},
}
</script>


<template>
	<AuthenRequired>
		<AppBox :title="$t('title')">
			<form id="form" @submit.prevent="onSubmit">
				<label for="name">{{  $t('name')  }}</label><br />
				<input id="name" :placeholder="$t('name')" required v-model="name" /><br />
				<br />

				<button type="submit">{{  $t('ok')  }}</button>
			</form>
		</AppBox>
	</AuthenRequired>
</template>


<style scoped>
</style>
